﻿#pragma once
#include <spdlog/spdlog.h>
#include "LLGL/LLGL.h"

#define MIRAGE_VERSION_MAJOR 0
#define MIRAGE_VERSION_MINOR 1
#define MIRAGE_VERSION_PATCH 0

namespace mirage {
    enum class renderer_api {
        dx11,
        dx12,
        vulkan,
        opengl,
        metal,
    };
    struct init_info {
#if MIRAGE_PLATFORM_WINDOWS
        renderer_api api = renderer_api::dx11;
#elif MIRAGE_PLATFORM_MACOS
        renderer_api api = renderer_api::metal;
#elif MIRAGE_PLATFORM_LINUX
        renderer_api api = renderer_api::vulkan;
#endif
    };
    int run(const init_info& in_init_info);

    const std::chrono::duration<double>& get_delta_time();
    std::chrono::duration<double> get_total_time();
}
